<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfacePersonResult_V6 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfacePersonResult_V6 extends AbstractStructArrayBase
{
    /**
     * The InterfacePersonResult_V6
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfacePersonResult_V6[]
     */
    public $InterfacePersonResult_V6;
    /**
     * Constructor method for ArrayOfInterfacePersonResult_V6
     * @uses ArrayOfInterfacePersonResult_V6::setInterfacePersonResult_V6()
     * @param \StructType\InterfacePersonResult_V6[] $interfacePersonResult_V6
     */
    public function __construct(array $interfacePersonResult_V6 = array())
    {
        $this
            ->setInterfacePersonResult_V6($interfacePersonResult_V6);
    }
    /**
     * Get InterfacePersonResult_V6 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfacePersonResult_V6[]|null
     */
    public function getInterfacePersonResult_V6()
    {
        return isset($this->InterfacePersonResult_V6) ? $this->InterfacePersonResult_V6 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfacePersonResult_V6 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfacePersonResult_V6 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfacePersonResult_V6ForArrayConstraintsFromSetInterfacePersonResult_V6(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item instanceof \StructType\InterfacePersonResult_V6) {
                $invalidValues[] = is_object($arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item) ? get_class($arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item) : sprintf('%s(%s)', gettype($arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item), var_export($arrayOfInterfacePersonResult_V6InterfacePersonResult_V6Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfacePersonResult_V6 property can only contain items of type \StructType\InterfacePersonResult_V6, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfacePersonResult_V6 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V6[] $interfacePersonResult_V6
     * @return \ArrayType\ArrayOfInterfacePersonResult_V6
     */
    public function setInterfacePersonResult_V6(array $interfacePersonResult_V6 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfacePersonResult_V6ArrayErrorMessage = self::validateInterfacePersonResult_V6ForArrayConstraintsFromSetInterfacePersonResult_V6($interfacePersonResult_V6))) {
            throw new \InvalidArgumentException($interfacePersonResult_V6ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfacePersonResult_V6) || (is_array($interfacePersonResult_V6) && empty($interfacePersonResult_V6))) {
            unset($this->InterfacePersonResult_V6);
        } else {
            $this->InterfacePersonResult_V6 = $interfacePersonResult_V6;
        }
        return $this;
    }
    /**
     * Add item to InterfacePersonResult_V6 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V6 $item
     * @return \ArrayType\ArrayOfInterfacePersonResult_V6
     */
    public function addToInterfacePersonResult_V6(\StructType\InterfacePersonResult_V6 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfacePersonResult_V6) {
            throw new \InvalidArgumentException(sprintf('The InterfacePersonResult_V6 property can only contain items of type \StructType\InterfacePersonResult_V6, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfacePersonResult_V6[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfacePersonResult_V6|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfacePersonResult_V6|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfacePersonResult_V6|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfacePersonResult_V6|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfacePersonResult_V6|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfacePersonResult_V6
     */
    public function getAttributeName()
    {
        return 'InterfacePersonResult_V6';
    }
}
